<?php

namespace Routee\WaymoreRoutee\Block\System\Config;

use Magento\Framework\Model\AbstractModel;

class Sendmassdata extends \Magento\Config\Block\System\Config\Form\Field
{
    protected $_template = 'Routee_WaymoreRoutee::system/config/sendmassdata.phtml';

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->scopeConfig = $scopeConfig;
        $this->_storeManager = $storeManager;
    }

    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        return $this->_toHtml();
    }
    public function getAjaxUrl()
    {
        return $this->getUrl(‘test.com’);
    }
    public function getButtonHtml()
    {
        $storeId = $this->_storeManager->getStore()->getId();
        $websiteId = $this->_storeManager->getStore()->getWebsiteId();
        $uuid = '';
        $button = '';
        if ($storeId > 0) {
            $uuid = $this->scopeConfig->getValue('waymoreroutee/general/uuid', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $storeId);
        } else {
            $uuid = $this->scopeConfig->getValue('waymoreroutee/general/uuid');
        }
        if ($uuid != '') {
	    $url = $this->getUrl('waymoreroutee/index/senddata').'?store_id='.$storeId.'&uuid='.$uuid;
	    //Check if mass data is already transferred over routee.net on 23rd Dec 2019
	    $dataTransferred = $this->scopeConfig->getValue('waymoreroutee/general/datatransferred');
	    if($dataTransferred==$uuid)
	    {
		$onClickEvent = $uuid;
	    }
	    else
	    {
		$onClickEvent = 'sendMassDataFunc("'.$url.'")';
	    }
	    //Check ends here 
            $button = $this->getLayout()->createBlock(
                'Magento\Backend\Block\Widget\Button'
            )->setData(
                [
                    'id' => 'send_mass_data',
                    'label' => __('Start Sync'),
                    'onclick' => $onClickEvent
                ]
            );
        }
        else {
            $button = $this->getLayout()->createBlock(
                'Magento\Backend\Block\Widget\Button'
            )->setData(
                [
                    'id' => 'send_mass_data',
                    'label' => __('Start Sync'),
                    'onclick' => 'javascript:alert("Please save config first!"); return false;'
                ]
            );
        }

        return $button->toHtml();
    }
}
