<?php

namespace Routee\WaymoreRoutee\Controller\Adminhtml\Index;

use \Magento\Backend\App\Action;
use \Magento\Backend\App\Action\Context;
use \Magento\Framework\App\ResponseInterface;
use \Magento\Framework\View\Result\PageFactory;
use \Magento\Framework\Controller\Result\JsonFactory;
use \Magento\Framework\App\Config\Storage\WriterInterface;
use Routee\WaymoreRoutee\Observer\Massapicustomers;
use Routee\WaymoreRoutee\Observer\Massapiproducts;
use Routee\WaymoreRoutee\Observer\Massapiorders;
use Routee\WaymoreRoutee\Observer\Massapiwishlists;
use Routee\WaymoreRoutee\Observer\Massapisubscribers;

class Senddata extends Action
{

    //protected $_resultPageFactory;

    //protected $_customerFactory;	
    public $_observer;
    public $_proobserver;
    public $_ordobserver;	
    public $_wishobserver;
    public $_subobserver;
    public $_saveconfig;	

    public function __construct(Context $context, JsonFactory $resultJsonFactory, WriterInterface $configWriter, Massapicustomers $observer, Massapiproducts $proobserver, Massapiorders $ordobserver, Massapiwishlists $wishobserver, Massapisubscribers $subobserver) {
    $this->resultJsonFactory = $resultJsonFactory;
    $this->_observer = $observer;
    $this->_proobserver = $proobserver;	
    $this->_ordobserver = $ordobserver;	
    $this->_wishobserver = $wishobserver;	
    $this->_subobserver = $subobserver;	
    $this->_saveconfig = $configWriter;
    parent::__construct($context);
}    

    protected function _isAllowed()
    {
        return true;
    }

    /**
     * Execute mass data sync with routee on button click
     * By Kapil Hanswal    
     */
    public function execute()
    {
	$result = $this->resultJsonFactory->create();
	if ($this->getRequest()->isAjax()) 
        {
		
		$customerData = $this->_observer->getCustomerData($_GET);
		if($customerData=='CustomerDone')
		{
			$subscriberData = $this->_subobserver->getSubscriberData($_GET);
			if($subscriberData=='SubscriberDone')
			{
				$productData = $this->_proobserver->getProductData($_GET);
				if($productData=='ProductDone')
				{
					$wishlistData = $this->_wishobserver->getWishlistData($_GET);				
					if($wishlistData=='WishlistDone')
					{
						$orderData = $this->_ordobserver->getOrderData($_GET);
						if($orderData=='OrderDone')
						{
							$this->_saveconfig->save('waymoreroutee/general/datatransferred', $_GET['uuid'], 'default', 0);
							echo json_encode(array("msg" => "IntegrationDone"));	
						}
					}
				}
			}
		}
        }        
    } 
}