<?php
namespace Routee\WaymoreRoutee\Helper;
 
use Magento\Framework\App\Helper\AbstractHelper;
 
class Data extends AbstractHelper
{
    /**
     * @var \Magento\Framework\App\Http\Context
     */
    private $httpContext;
 
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Framework\App\Http\Context $httpContext,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) 
    {
        parent::__construct($context);
        $this->httpContext = $httpContext;
		$this->scopeConfig = $scopeConfig;
    }
 
    public function getApiurl()
    {
        $testMode = $this->scopeConfig->getValue('waymoreroutee/general/testmode');
		//$apiUrl = $this->httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH);
		if($testMode) {
			$apiUrl = 'https://dev-waymore.routee.net/api/';
		}
		else {
			$apiUrl = 'https://waymore.routee.net/api/';
		}
        return $apiUrl;
    }
	
	public function getDataApiurl()
    {
        $testMode = $this->scopeConfig->getValue('waymoreroutee/general/testmode');
		//$apiUrl = $this->httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH);
		if($testMode) {
			$apiUrl = 'https://dev-idata.routee.net/api/data';
		}
		else {
			$apiUrl = 'https://idata.routee.net/api/data';
		}
        return $apiUrl;
    }
	
	public function getEventApiurl()
    {
        $testMode = $this->scopeConfig->getValue('waymoreroutee/general/testmode');
		//$apiUrl = $this->httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH);
		if($testMode) {
			$apiUrl = 'https://dev-idata.routee.net/api/event';
		}
		else {
			$apiUrl = 'https://idata.routee.net/api/event';
		}
        return $apiUrl;
    }
	
	public function getUuid($storeId = null)
    {
        if($storeId > 0) {
			return $this->scopeConfig->getValue('waymoreroutee/general/uuid', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $storeId);
		}
		else {
			return $this->scopeConfig->getValue('waymoreroutee/general/uuid');
		}
    }
	
	public function getUsername($storeId = null)
    {
        if($storeId > 0) {
            return $this->scopeConfig->getValue('waymoreroutee/general/username', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $storeId);
        }
        else {
            return $this->scopeConfig->getValue('waymoreroutee/general/username');
        }
    }
	
	public function getPassword($storeId = null)
    {
        if($storeId > 0) {
            return $this->scopeConfig->getValue('waymoreroutee/general/password', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $storeId);
        }
        else {
            return $this->scopeConfig->getValue('waymoreroutee/general/password');
        }
    }
	
	public function getIsEnabled($storeId = null)
    {
        if($storeId > 0) {
            return $this->scopeConfig->getValue('waymoreroutee/general/enable', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $storeId);
        }
        else {
            return $this->scopeConfig->getValue('waymoreroutee/general/enable');
        }
    }
}