<?php
namespace Routee\WaymoreRoutee\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;
use Psr\Log\LoggerInterface as Logger;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Customer\Model\Session;

class Eventnewsletter implements ObserverInterface
{
	protected $_logger;

	/**
	 * @param \Psr\Log\LoggerInterface $_logger
	 */

	public function __construct(
		\Routee\WaymoreRoutee\Helper\Data $helper,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Framework\App\Config\ConfigResource\ConfigInterface $configInterface,
		\Magento\Framework\HTTP\Client\Curl $curl,
		\Magento\Framework\ObjectManagerInterface $objectmanager,
		\Magento\Framework\Module\ResourceInterface $moduleResource,
		\Magento\Store\Model\StoreManagerInterface $storeManager,
		\Magento\Framework\Event\Manager $eventManager,
		\Magento\Sales\Model\OrderFactory $order,	
		\Magento\Framework\UrlInterface $urlInterface,
		Session $customerSession,	
		\Psr\Log\LoggerInterface $_logger
	){
		$this->helper = $helper;
		$this->scopeConfig = $scopeConfig;
		$this->_configInterface = $configInterface;
		$this->_curl = $curl;
		$this->_objectManager = $objectmanager;
		$this->moduleResource = $moduleResource;
		$this->_storeManager = $storeManager;
		$this->_eventManager = $eventManager;
		$this->_logger = $_logger;
		$this->_order = $order;
		$this->_urlInterface = $urlInterface;
		$this->_customerSession = $customerSession;
	}


	public function execute(EventObserver $observer)
	{
		$isEnabled = $this->helper->getIsEnabled();
		//getStoreId
		if($isEnabled) {
			
			$storeId = $this->_storeManager->getStore()->getId();	
			$uuid = $this->helper->getUuid($storeId);
			$customerId = $this->_customerSession->getCustomer()->getId();
			$isSubscribed = $observer->getEvent()->getSubscriber()->getSubscriberStatus();
			$apiUrl = $this->helper->getEventApiurl();		
			if($customerId < 1) {
				$customerId = 0;	
			}
			
			$data = array();
			$productDetails = array();
			$data['uuid'] = $uuid;
			$data['event'] = 'Newsletter';
			$data['data']['customer_id'] = $customerId;
			$data['data']['email'] = $observer->getEvent()->getSubscriber()->getSubscriberEmail();
			$data['data']['subscription'] = ($isSubscribed == '1')?'true':'false';		
			
			
			$res = json_encode($data['data']);
			$result = '{"uuid": "'.$uuid.'", "event": "Newsletter", "data":'.$res.'}';
			
			$this->_curl->post($apiUrl, $result);
			$this->_curl->addHeader("Content-Type", "application/json");
			$this->_curl->setOption(CURLOPT_RETURNTRANSFER, true);
			//response will contain the output in form of JSON string
			
			$response = $this->_curl->getBody();
			$responseArr = json_decode($response, true);			
		}
	}
}