<?php
namespace Routee\WaymoreRoutee\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;
use Psr\Log\LoggerInterface as Logger;
use Magento\Framework\App\Config\ScopeConfigInterface;

class Eventproductoutofstock implements ObserverInterface
{
	protected $_logger;

	/**
	 * @param \Psr\Log\LoggerInterface $_logger
	 */

	public function __construct(
		\Routee\WaymoreRoutee\Helper\Data $helper,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Framework\App\Config\ConfigResource\ConfigInterface $configInterface,
		\Magento\Framework\HTTP\Client\Curl $curl,
		\Magento\Framework\ObjectManagerInterface $objectmanager,
		\Magento\Framework\Module\ResourceInterface $moduleResource,
		\Magento\Store\Model\StoreManagerInterface $storeManager,
		\Magento\Framework\Event\Manager $eventManager,
		\Magento\Sales\Model\OrderFactory $order,	
		\Magento\Framework\UrlInterface $urlInterface,	
		\Psr\Log\LoggerInterface $_logger
	){
		$this->helper = $helper;
		$this->scopeConfig = $scopeConfig;
		$this->_configInterface = $configInterface;
		$this->_curl = $curl;
		$this->_objectManager = $objectmanager;
		$this->moduleResource = $moduleResource;
		$this->_storeManager = $storeManager;
		$this->_eventManager = $eventManager;
		$this->_logger = $_logger;
		$this->_order = $order;
		$this->_urlInterface = $urlInterface;
	}


	public function execute(EventObserver $observer)
	{
		$isEnabled = $this->helper->getIsEnabled();
		//getStoreId
		if($isEnabled) {
			$product = $observer->getEvent()->getProduct();
			$id = $product->getId(); //Get Product Id
			$storeId = $this->_storeManager->getStore()->getId();	
			$uuid = $this->helper->getUuid($storeId);
			$apiUrl = $this->helper->getEventApiurl();		
			
			//Old implementation to get stock quantity but commented by KH on 14th Jan
			//$qty = $this->_stockItem->getStockItem($product->getId())->getQty();
			
			$getStockItem = $product->getExtensionAttributes()->getStockItem();
			if(isset($getStockItem))
			{
				$qty = $getStockItem->getQty();
			
				if($qty < 1) {
					$data = array();
					$data['uuid'] = $uuid;
					$data['event'] = 'ProductOutOfStock';
					$data['data']['product_id'] = $id;
					
					
					$res = json_encode($data['data']);
					$result = '{"uuid": "'.$uuid.'", "event": "ProductOutOfStock", "data":'.$res.'}';
					
					$this->_curl->post($apiUrl, $result);
					$this->_curl->addHeader("Content-Type", "application/json");
					$this->_curl->setOption(CURLOPT_RETURNTRANSFER, true);
					//response will contain the output in form of JSON string
					
					$response = $this->_curl->getBody();
					$responseArr = json_decode($response, true);				
				}
			}
		}
	}
}