<?php
namespace Routee\WaymoreRoutee\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;
use Psr\Log\LoggerInterface as Logger;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Customer\Model\Session;

class Eventwishlistremove implements ObserverInterface
{
	protected $_logger;

	/**
	 * @param \Psr\Log\LoggerInterface $_logger
	 */

	/**
	 * @var \Magento\Framework\App\RequestInterface
	 */
	public $request;

	public function __construct(
		\Routee\WaymoreRoutee\Helper\Data $helper,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Framework\App\Config\ConfigResource\ConfigInterface $configInterface,
		\Magento\Framework\HTTP\Client\Curl $curl,
		\Magento\Framework\ObjectManagerInterface $objectmanager,
		\Magento\Framework\Module\ResourceInterface $moduleResource,
		\Magento\Store\Model\StoreManagerInterface $storeManager,
		\Magento\Framework\Event\Manager $eventManager,
		\Magento\Sales\Model\OrderFactory $order,	
		\Magento\Framework\UrlInterface $urlInterface,
		Session $customerSession,	
		\Psr\Log\LoggerInterface $_logger,
		\Magento\Framework\App\RequestInterface $request
	){
		$this->helper = $helper;
		$this->scopeConfig = $scopeConfig;
		$this->_configInterface = $configInterface;
		$this->_curl = $curl;
		$this->_objectManager = $objectmanager;
		$this->moduleResource = $moduleResource;
		$this->_storeManager = $storeManager;
		$this->_eventManager = $eventManager;
		$this->_logger = $_logger;
		$this->_order = $order;
		$this->_urlInterface = $urlInterface;
		$this->_customerSession = $customerSession;
		$this->request = $request;
	}


	public function execute(EventObserver $observer)
	{
		$isEnabled = $this->helper->getIsEnabled();
		//getStoreId
		if($isEnabled) {
			$wishlistItem = $observer->getItems();
			/*Get item id and then pass into item collection to know the product id which is required to pass over routee json*/
			$item = $this->request->getParam('item');
			$wishlistItemCollection = $this->_objectManager->get('Magento\Wishlist\Model\ResourceModel\Item\Collection')->addFieldToFilter('wishlist_item_id', ['eq' => $item]);
			foreach($wishlistItemCollection as $wishlistData){
            	$productId = $wishlistData->getProductId();                  	
			}
			/*Ends here*/
			//$allitems =  $cart->getQuote()->getAllVisibleItems();
			$storeId = $this->_storeManager->getStore()->getId();	
			$uuid = $this->helper->getUuid($storeId);
			$customerId = $this->_customerSession->getCustomer()->getId();
			
			$apiUrl = $this->helper->getEventApiurl();		
			
			$data = array();
			$productDetails = array();
			$data['uuid'] = $uuid;
			$data['event'] = 'WishlistDelete';
			$data['data']['customer_id'] = $customerId;
			$data['data']['product_id'] = $productId;		
			
			
			$res = json_encode($data['data']);
			$result = '{"uuid": "'.$uuid.'", "event": "WishlistDelete", "data":'.$res.'}';
			
			
			$this->_curl->post($apiUrl, $result);
			$this->_curl->addHeader("Content-Type", "application/json");
			$this->_curl->setOption(CURLOPT_RETURNTRANSFER, true);
			//response will contain the output in form of JSON string
			
			$response = $this->_curl->getBody();
			$responseArr = json_decode($response, true);
		}
	}
}